/*
 * WiiChuckDemo -- 
 *
 * 2008 Tod E. Kurt, http://thingm.com/
 *
 */
 /* EDIT add function nunchuck_accelx10,nunchuck_accely10,nunchuck_accelz10
 * Junichirou Tahara 2010/09/19
 */

#include <Wire.h>
#include "nunchuck_funcs.h"

int nunchuck_accelx10()
{ 
    int accel_x_axis= nunchuck_buf[2]; // * 2 * 2;  
    if ((nunchuck_buf[5] >> 2) & 1) {
        accel_x_axis += 2;
    }
    if ((nunchuck_buf[5] >> 3) & 1) {
        accel_x_axis += 1;
    }  
return accel_x_axis;
}

int nunchuck_accely10()
{
    int accel_y_axis = nunchuck_buf[3]; // * 2 * 2; 
    
    if ((nunchuck_buf[5] >> 4) & 1) {
        accel_y_axis += 2;
    }
    if ((nunchuck_buf[5] >> 5) & 1) {
        accel_y_axis += 1;
    }
return accel_y_axis;        
}

int nunchuck_accelz10() {
    int accel_z_axis = nunchuck_buf[4]; // * 2 * 2;
    
    if ((nunchuck_buf[5] >> 6) & 1) {
        accel_z_axis += 2;
    }
    if ((nunchuck_buf[5] >> 7) & 1) {
        accel_z_axis += 1;
    }
return accel_z_axis;    
}




int loop_cnt=0;

int accx,accy,accz;
int zbut,cbut;
int jx,jy;

int ledPin = 13;


void setup()
{
    Serial.begin(19200);
    nunchuck_setpowerpins();
    nunchuck_init(); // send the initilization handshake
    
    Serial.print("WiiChuckDemo ready\n");
}

void loop()
{
    if( loop_cnt > 10 ) { // every 10 msecs get new data
        loop_cnt = 0;

        nunchuck_get_data();
       
        accx  = nunchuck_accelx10(); 
        accy  = nunchuck_accely10();
        accz  = nunchuck_accelz10();
        
        zbut = nunchuck_zbutton();
        cbut = nunchuck_cbutton();
       
        jx =  nunchuck_joyx();
        jy =  nunchuck_joyy(); 
        //nunchuck_print_data();
           
        Serial.print(accx);
        Serial.print(",");
        Serial.print(accy);
        Serial.print(",");       
        Serial.print(accz);
        Serial.print(",");
        
        Serial.print(jx);
        Serial.print(",");
        Serial.print(jy);
        Serial.print(",");
        
        Serial.print(zbut);
        Serial.print(",");
        Serial.print(cbut);
        Serial.print("\n");
        
    }
    loop_cnt++;
    //delay(1);
}

