import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;

SawWave sine;
Minim minim;
AudioOutput out;
WaveformRenderer waveform;


void setup()
{
  size(512, 200, P2D);
  
  minim = new Minim(this);
  out = minim.getLineOut(Minim.STEREO);
  
  sine = new SawWave(440, 1.5, out.sampleRate());//サイン波
  out.addSignal(sine);
  
  waveform = new WaveformRenderer();
  out.addListener(waveform);
}

void draw()
{
  background(0);
  // see waveform.pde for an explanation of how this works
  waveform.draw();
}

void stop()
{
  // always close Minim audio classes when you are done with them
  out.close();
  // always stop Minim before exiting.
  minim.stop();
  super.stop();
}
