import pqrcode.*;
import controlP5.*;

//ControlP5オブジェクトの作成
ControlP5 load;
ControlP5 decode;
ControlP5 CP5text;
ControlP5 encode;
ControlP5 Qsave;

//文字列
String SW = "*";//selectinputのバグ用nullがはいると困るので適当なありえない文字
String loadPath="";//ファイルアクセスするするQRコードのファイルパス
String Qstring="";//Qrコードからデコードされた文字列
String textValue="";//入力された文字列
String MES="ファイルを選択してください";//状態表示
//javaの１行文字列
Textfield CP5Textfield;

//画像
PImage img;//ファイルから読み込んだイメージ
PImage img2;//文字から作った新しいイメージ

boolean img_fast = true;//２回目以降はfalse

//Decoderオブジェクト
Decoder Qdecoder;

void setup() {
smooth();
size(600,400);
load = new ControlP5(this);
decode = new ControlP5(this);
Qdecoder= new Decoder(this);
CP5text = new ControlP5(this);
encode = new ControlP5(this);
Qsave = new ControlP5(this);

load.addButton("load",1,300,50,50,20);
decode.addButton("decode",2,300,90,50,20);

//                                  関数名,x,y,xの終わりの位置,高さ
CP5Textfield =CP5text.addTextfield("INPUT",300,200,180,20);
//                 関数名,ID,x  ,y,  w,h
CP5text.addButton("submit",0,300,240,40,20);

encode.addButton("encode",1,300,280,40,20);

Qsave.addButton("qrsave",3,300,320,40,20);
background(0);
}

void draw() {
fill(255);
textSize(16);
text(MES,160,20);
text(loadPath,160,40);
text(Qstring,160,80);
text(textValue,20,210);
  if(img_fast != true) {
  image(img,0,0);
  }
}



public void load(int val) {
  background(0);
  MES = "ファイル選択されました";
  loadPath = selectInput("load"); //ファイルチューザーを開く
    //nullだったとき表示する．
    if (loadPath == null) {
      loadPath=SW;//null返しするとJavaがとまるのでありえない文字にしている．
      println("slect QRcode PNG");
    } else {
      if( filechk(loadPath,"png")) {
      img = loadImage(loadPath);
      img_fast = false;
      Qdecoder.decodeImage(img);//デーコード用画像とする
      }
    }
println("end");
println(loadPath);
}

boolean filechk(String name,String chk) {
  boolean ans=false;
  //拡張子を.以降の文字とする
  String ext = name.substring(name.lastIndexOf('.') + 1);
  //拡張子を小文字にする
  ext.toLowerCase();
  //正しいなら正を返す
  if(ext.equals(chk)){
  ans=true;
  }
 return ans;
}

void decode(int val) {
background(0);
//Qdecoder.decodeImage(img);//デーコード用画像とする
//解読結果をテキストとして取り出す
Qstring  = Qdecoder.getDecodedString();
//テキストを画面に出力
MES = "QRコードからデータに変換しました";

print(Qstring);
}

void submit(int theValue) {
  background(0);
  MES="文字列を入力しました．ENCODEを押してください";
  //関数名はCP5text.addButtonできめた関数姪にする
  //引数は関数が実行されると自動代入されるのでグローバル変数にわたす
  CP5Textfield.submit();//再び自分自身を呼ぶ
}

void INPUT(String theText) {
  //関数名はCP5text.addTextfieldできめた関数姪にする
  //引数は関数が実行されると自動代入されるのでグローバル変数にわたす
  println("a textfield event for controller 'texting': "+theText);
  textValue=theText;
}

void encode(int x) {
  img_fast = false;
  background(0);
  MES="QRコードに変化しました";
  String URL;
  if(textValue != null) {
    URL=mk_google_str(textValue);
    img = loadImage(URL,"PNG");//表示用イメージを作成
    Qdecoder.decodeImage(img);//QRコードに変換するイメージを再度読み込む
  }
}

String mk_google_str(String chl) {
  String QR_google_api = "http://chart.apis.google.com/chart?";
  String chs ="150";//QRコードの大きさ

  //QRコードに変換したい文字列
  //String chl = "www.cutt.co.jp";

  //Googleに渡す文字列をつくる
  String URL;
  URL = QR_google_api + "chs="+ chs + "x" + chs + "&" + "cht=qr" + "&" + "chl=" + chl;
  println(URL);
  return URL;
}

void qrsave(int val) {
  background(0);
  MES ="QRコードを保存します";
  if(img_fast == true) {
  MES="画像が生成されていません";
  } else {
  MES ="QRコードを保存しました";
  loadPath = selectOutput("write"); //ファイルチューザーを開く
    if(loadPath == null) {
      loadPath=SW;//null返しするとJavaがとまるのでありえない文字にしている．
      println("slect QRcode PNG");
    } else {
      img.save(loadPath);
    }
  println("Path"+loadPath);
  }
}
