//注意同一フォルダー内にwaveform.pdeを同一のフォルダーに入れること
//そうしないとクラスがないのエラーがでる．
//miniライブラリーのインストール
import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;


Minim minim;//Minim オブジェクトを定義
AudioOutput out;//オーディオ出力を定義
WaveformRenderer waveform;//波形画面を定義
SineWave sinwave;//サイン波のクラス
SquareWave sqrwave;//方形波のクラス
TriangleWave triwave;//三角波のクラス
SawWave sawwave;//鋸波のクラス


void setup()
{
  size(512, 200);
  
  minim = new Minim(this);//minimを使えるようにする
  out = minim.getLineOut(Minim.STEREO);//出力先をoutにするSTEREO出力，モノラルにするにはMONO
  
  triwave = new TriangleWave(440, 0.5, out.sampleRate());//三角波を作る
  sqrwave = new SquareWave(440, 0.5, out.sampleRate());//方形波を作る
  
  out.addSignal(triwave);//出力autoに三角波を追加
  out.addSignal(sqrwave);//出力autoに方形波を追加
  
  waveform = new WaveformRenderer();//waveformを使えるようにするグラフィック
  out.addListener(waveform);//グラフィックに出力する
}

void draw()
{
  background(0);
  waveform.draw();//グラフィックを表示
}

//音の停止
void stop()
{
  out.close();
  minim.stop();
  super.stop();
}
