//OpenGLを読み込む
import processing.opengl.*;

PImage tex;
float rotx = PI/4;
float roty = PI/4;

void setup() 
{
  size(640, 360,OPENGL);
  //jpegを読み込む
  tex = loadImage("cutt.jpg");
  textureMode(NORMALIZED);
}

void draw() 
{
  background(0);
  noStroke();
  translate(width/2.0, height/2.0, -100);
  rotateX(rotx);
  rotateY(roty);
  scale(90);//９０倍する
  TexturedCube(tex);//箱をつくる
}

void TexturedCube(PImage tex) {
  //四角形なので４つの頂点を使うことをしめす
  //形の定義開始
  beginShape(QUADS);
  //texture画像を設定
  texture(tex);
  
  // +Z "front" face
  vertex(-1, -1,  1, 0, 0);//A
  vertex( 1, -1,  1, 1, 0);//B
  vertex( 1,  1,  1, 1, 1);//C
  vertex(-1,  1,  1, 0, 1);//D

  // -Z "back" face
  vertex( 1, -1, -1, 0, 0);
  vertex(-1, -1, -1, 1, 0);
  vertex(-1,  1, -1, 1, 1);
  vertex( 1,  1, -1, 0, 1);

  // +Y "bottom" face
  vertex(-1,  1,  1, 0, 0);
  vertex( 1,  1,  1, 1, 0);
  vertex( 1,  1, -1, 1, 1);
  vertex(-1,  1, -1, 0, 1);

  // -Y "top" face
  vertex(-1, -1, -1, 0, 0);
  vertex( 1, -1, -1, 1, 0);
  vertex( 1, -1,  1, 1, 1);
  vertex(-1, -1,  1, 0, 1);

  // +X "right" face
  vertex( 1, -1,  1, 0, 0);
  vertex( 1, -1, -1, 1, 0);
  vertex( 1,  1, -1, 1, 1);
  vertex( 1,  1,  1, 0, 1);

  // -X "left" face
  vertex(-1, -1, -1, 0, 0);
  vertex(-1, -1,  1, 1, 0);
  vertex(-1,  1,  1, 1, 1);
  vertex(-1,  1, -1, 0, 1);


  endShape();
 //形の定義終了
}

void mouseDragged() {
  float rate = 0.01;
  rotx += (pmouseY-mouseY) * rate;
  roty += (mouseX-pmouseX) * rate;
}
