//ライブラリを取り入れる
import processing.video.*;
import pqrcode.*;


//Decoderオブジェクトを作る
Decoder decoder;

//キャプチャする映像のオブジェクトを用意
Capture myCapture;

//イメージ画像
PImage img;

//文字列
String mes = "";//QRコードの文字列
String old = "";//古い文字列

void setup() {
  size(400,320);
  //オブジェクトの生成
  decoder = new Decoder(this);
  myCapture = new Capture(this, width, height,30);  
}

void decoderEvent(Decoder decoder) {
  //デコードから文字列を取り出す
  mes = decoder.getDecodedString();
  //QRコードであったら印刷
  if(mes.equals("NO QRcode image found") == false) {
  println(mes);
  }
}

void captureEvent(Capture video) {
  video.read();
}

void draw() {
//ウインドウに動画を貼り付ける
image(myCapture,0,0,width,height);
//白黒にすると認識率がアップする0.3~0.5がよい
filter(THRESHOLD,0.3);
}

void mousePressed() {
//イメージの解読
//キャプチャー画像からイメージを作るRGBよりもALPAHのほうが良い
img = createImage(myCapture.width,myCapture.height,ALPHA);
//イメージをコピー
img.copy(myCapture, 0,0,myCapture.width,myCapture.height,0,0,myCapture.width,myCapture.height);
//イメージを更新
img.updatePixels();
//イメージをQRコードとしてデコードする
decoder.decodeImage(img);
}
